<template>
  <v-container class="pa-0">
    <div class="mb-4 d-flex align-center">
      <span class="font-weight-bold">Importer liste PAX</span>
      <v-divider vertical class="ml-4 mr-2"></v-divider>
      <a href="/files/Modele_fichier_PAX.xlsx" data-cy="PaxDownloadFileBtn" download>
        <v-btn flat rounded>
          <v-icon left>file_download</v-icon>
          Télécharger modèle du fichier
        </v-btn>
      </a>
    </div>
    <v-row>
      <v-col cols="12" sm="4" class="mb-4">
        <v-file-input v-model="file" variant="outlined" density="compact" label="Importer liste PAX" data-cy="PaxImportFileInput"
          :disabled="loading || fileLoading || flight.archived" :accept="'.xlsx'" class="hide-details"
          @change="askParseFile()">
        </v-file-input>
        <v-progress-circular v-if="fileLoading" indeterminate class="ml-2" color="primary">
        </v-progress-circular>
      </v-col>
    </v-row>

    <FlightsCasePaxList :pax-list="paxList" :flight="flight" @hasErrors="hasErrors = $event"
      @deletePax="deletePax($event)" @createEditPax="createEditPax($event)">
    </FlightsCasePaxList>
    <Teleport to="#teleports">
      <v-toolbar class="footer-action-toolbar" color="white">
        <v-spacer></v-spacer>
        <v-menu v-if="showFinalize && !flight.archived" top offset-y>
          <template #activator="{ props }">
            <v-btn variant="outlined" rounded size="large" :loading="loading" v-bind="props" data-cy="PaxImportChooseFinalizeBtn"
              class="mr-4 inverted text-uppercase">
              Finaliser
            </v-btn>
          </template>
          <v-list>
            <v-list-item v-for="(leg, index) in flight.legs" :key="index">
              <v-list-item-title>
                <div class="d-flex align-center">
                  <v-avatar size="30" class="mr-4 outlined">
                    {{ index + 1 }}
                  </v-avatar>
                  {{ leg.departure.oaci }} > {{ leg.arrival.oaci }}
                  <v-chip class="ml-4 text-uppercase status-chip" label :class="getStatusClass(leg.status)">
                    {{ legStatus[leg.status] }}
                  </v-chip>
                  <v-btn variant="outlined" rounded size="large" :loading="loading" :disabled="!canFinalize(leg) || flight.archived"
                    data-cy="PaxImportFinalizeBtn" class="ml-4 inverted text-uppercase" @click="askFinalize(leg)">
                    Finaliser
                  </v-btn>
                </div>
              </v-list-item-title>
            </v-list-item>
          </v-list>
        </v-menu>
        <v-btn variant="outlined" rounded size="large"
          :disabled="paxToSave.length > 0 || paxToDelete.length > 0 || paxList.length < 1 || flight.archived"
          :loading="loading" data-cy="PaxImportExportBtn" class="mr-4 text-uppercase" @click="exportPaxList">
          Exporter liste PAX
        </v-btn>
        <v-btn variant="outlined" rounded size="large"
          :disabled="(!isNewImportPaxList && paxToSave.length < 1 && paxToDelete.length < 1 && paxList.findIndex(p => !p.id) < 0) || hasErrors || fileLoading || flight.archived"
          :loading="loading" data-cy="PaxImportSaveBtn" class="inverted text-uppercase" @click="savePaxList">
          Enregistrer liste PAX
        </v-btn>
      </v-toolbar>
    </Teleport>
    <LazyFlightsCaseImportDialog v-if="importDialog" v-model="importDialog" @confirm="parseFile($event)"
      @close="importDialog = false" />

    <LazyFlightsCaseFinalizeDialog v-if="finalizeDialog" v-model="finalizeDialog" :leg-status="legSelected?.status"
      @confirm="finalize($event)" @close="finalizeDialog = false; legSelected = null;" />
  </v-container>
</template>

<script setup lang="ts">
import { saveAs } from 'file-saver';
import { editList, getStatusClass } from "../../../mixins/utilsMixin";
import { LegStatus } from "~/dto/legstatus.enum";
import { Flight } from "~/dto/flight.dto";
import { Leg } from "~/dto/leg.dto";
import { Pax } from "~/dto/pax.dto";
import { Aircraft } from "~/dto/aircraft.dto";

const { $api, $toast } = useNuxtApp();

const props = defineProps<{
  flight: Flight
}>()
const emit = defineEmits(['dataNotSaved']);

const legStatus = LegStatus;

// @ts-ignore
const paxList: Ref<Pax[]> = ref([...props.flight.paxs]);
const paxToSave: Ref<number[]> = ref([]);
const paxToDelete: Ref<number[]> = ref([]);
const legSelected: Ref<Leg | null> = ref(null);
const file: Ref<any> = ref(null);
const importDialog = ref(false);
const fileLoading = ref(false);
const loading = ref(false);
const isNewImportPaxList = ref(false);
const showFinalize = ref(false);
const finalizeDialog = ref(false);
const hasErrors = ref(false);
const store = useStore();

const aircrafts: Ref<Aircraft[]> = computed(() => {
  return store.aircrafts;
});
const totalAircraftCapacity: Ref<number | undefined> = computed(() => {
  return aircrafts.value.find(a => a.name === props.flight?.aircraft?.name)?.seatsTemplate.length;
});

const askParseFile = () => {
  if (!file.value) {
    return;
  }
  if (paxList.value && paxList.value.length < 1) {
    return parseFile(false);
  }
  importDialog.value = true;
}

const parseFile = async (deletePaxs: boolean) => {
  if (!file.value) {
    return;
  }
  const filesize = (file.value.size / 1024 / 1024);
  if (filesize > 5) {
    $toast.error('Le poids du fichier doit être inférieur à 5Mb.');
    return;
  }

  fileLoading.value = true;
  try {
    const newPaxs = await $api.pax.parse(props.flight.id, file.value);
    const fullPaxs = deletePaxs ? newPaxs : paxList.value.concat(newPaxs);

    if (!checkCapacity(getMaxPaxByLeg(fullPaxs))) {
      importDialog.value = false;
      fileLoading.value = false;
      return;
    }
    let lowerIndex = paxList.value.reduce((prev: number, current: Pax) => prev < current.id ? prev : current.id, 0);
    lowerIndex = lowerIndex > 0 ? 0 : lowerIndex;
    newPaxs.forEach((p: Pax) => {
      lowerIndex--;
      p.id = lowerIndex;
      paxToSave.value.push(p.id);
    });
    if (deletePaxs) {
      paxList.value.forEach(p => paxToDelete.value.push(p.id));
    }
    paxList.value = deletePaxs ? [...newPaxs] : paxList.value.concat(newPaxs);
    if (newPaxs.length < 1) {
      $toast.warning(`Le fichier a bien été lu mais aucune donnée n'est présente.`);
    }
    isNewImportPaxList.value = true;
    emit('dataNotSaved', true);
  } catch (e) {
    $toast.error("Erreur lors de l'import de la liste de PAX");
  }
  importDialog.value = false;
  fileLoading.value = false;
}

const savePaxList = async () => {
  try {
    loading.value = true;
    paxList.value = await $api.pax.updateList(getPayload(), props.flight.id);
    props.flight.paxs = [...paxList.value];
    await Promise.all(props.flight.legs.map(async (l) => {
      l.status = await $api.leg.getStatus(l.id);
    }));
    isNewImportPaxList.value = false;
    paxToSave.value = [];
    paxToDelete.value = [];
    emit('dataNotSaved', false);
    $toast.success('Liste de PAX enregistrée');
  } catch (e) {
    $toast.error("Erreur lors de l'enregistrement de la liste de PAX");
  }
  loading.value = false;
}

const exportPaxList = async () => {
  try {
    loading.value = true;
    const res = await $api.pax.exportList(props.flight.id);
    const blob = new Blob([res], {
      type: 'application/vnd.ms-excel'
    });

    saveAs(blob, `LISTE_PAX.xlsx`);
  } catch (e) {
    $toast.error("Erreur lors de l'export de la liste de PAX");
  }
  loading.value = false;
}

const createEditPax = (pax: Pax) => {
  if (!pax.id) {
    if (!checkCapacity(getMaxPaxByLeg(paxList.value.concat([pax])))) {
      return;
    }
    let lowerIndex = paxList.value.reduce((prev: number, current: Pax) => prev < current.id ? prev : current.id, 0);
    lowerIndex = lowerIndex > 0 ? 0 : lowerIndex;
    pax.id = lowerIndex - 1;
  }
  paxList.value = editList(paxList.value, pax);
  props.flight.paxs = [...paxList.value];
  if (pax.id && paxToSave.value.findIndex(paxId => paxId === pax.id) < 0) {
    paxToSave.value.push(pax.id);
    emit('dataNotSaved', true);
  }
}

const deletePax = (pax: Pax) => {
  paxList.value = paxList.value.filter(p => p.id !== pax.id);
  props.flight.paxs = [...paxList.value];
  paxToDelete.value.push(pax.id);
  emit('dataNotSaved', true);
}

const checkCapacity = (newCapacity: number): boolean => {
  if (!props.flight.aircraft) {
    return true;
  }
  if (totalAircraftCapacity.value && totalAircraftCapacity.value < newCapacity) {
    $toast.error(`Le nombre total de PAX dépasse la capacité maximale de l'appareil qui est de ${totalAircraftCapacity.value} passagers.`);
    return false;
  }
  return true;
}

const checkAircraft = () => {
  const aircraft = JSON.parse(JSON.stringify(props.flight.aircraft));
  showFinalize.value = !(!!aircraft && aircraft.name !== 'Free Seating');
}

const getPayload = () => {
  let paxs = paxList.value.filter(p => paxToSave.value.includes(p.id));
  paxs = paxs.map(p => {
    // @ts-ignore
    p.id = p.id < 0 ? null : p.id;
    // @ts-ignore
    delete p.legs;
    return p;
  })
  return { paxs: formatPaxList(paxs), to_delete: paxToDelete.value.filter(id => id >= 0) };
}

const formatPaxList = (paxs: Pax[]): Pax[] => {
  // @ts-expect-error
  return paxs.map(p => formatPax(p));
}

const formatPax = (pax: Pax): Partial<Pax> => {
  const paxToReturn = { ...pax } as Partial<Pax>;
  paxToReturn.number = !Number.isNaN(paxToReturn.number) ? Number(paxToReturn.number) : undefined;
  paxToReturn.weight = !Number.isNaN(paxToReturn.weight) ? Number(paxToReturn.weight) : undefined;
  paxToReturn.luggageWeight = !Number.isNaN(paxToReturn.luggageWeight) ? Number(paxToReturn.luggageWeight) : undefined;
  paxToReturn.birthdate = paxToReturn.birthdate ? paxToReturn.birthdate.toString() : undefined;
  // @ts-expect-error
  paxToReturn.flight = { id: props.flight.id };
  return paxToReturn;
}

const canFinalize = (leg: Leg): boolean => {
  return ['scheduled', 'lmc'].includes(leg.status);
}

const askFinalize = (leg: Leg) => {
  if (!canFinalize(leg) || !showFinalize.value) {
    return;
  }
  legSelected.value = leg;
  finalizeDialog.value = true;
}

const finalize = async ($event: any) => {
  loading.value = true;
  const leg = props.flight.legs.find(l => l.id === legSelected.value?.id);
  if (leg) {
    try {
      leg.documents = (await $api.leg.finalize(leg.id, $event)).documents;
      leg.status = await $api.leg.getStatus(leg.id);
      props.flight.documents = await $api.flightPaginated.getDocuments(props.flight.id);
      $toast.success("Génération des documents effectué");
    } catch (e) {
      $toast.error("Erreur lors de la génération des documents");
    }
    finalizeDialog.value = false;
    loading.value = false;
  }
}

const getMaxPaxByLeg = (paxs: Pax[]): number => {
  const paxsByLeg: any[] = [];
  paxs.forEach(p => {
    p.legs.forEach(l => {
      const index = paxsByLeg.findIndex(pl => pl.leg === l.id);
      if (index >= 0) {
        paxsByLeg[index].count++;
      } else {
        paxsByLeg.push({
          leg: l.id,
          count: 1
        });
      }
    });
  });

  return Math.max(...paxsByLeg.map(pl => pl.count));
}

watch(() => props.flight, () => {
  paxList.value = [...props.flight.paxs];
  checkAircraft();
});

onMounted(() => {
  checkAircraft();
});
</script>
